﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ComponentModel;
using System.Collections.ObjectModel;

namespace XamDataGridClipboard
{
    public class UserViewModel :INotifyPropertyChanged 
    {
        private User user;

        public UserViewModel() : this(new User("", "", "", 0)) { }

        public UserViewModel(User u)
        {
            user = u;
        }

        public string Username
        {
            get { return user.Username; }
            set
            {
                user.Username = value;
                NotifyPropertyChanged("Username");
            }
        }

        public string Password
        {
            get { return user.Password; }
            set
            {
                user.Password = value;
                NotifyPropertyChanged("Password");
            }
        }

        public string Email
        {
            get { return user.Email; }
            set
            {
                user.Email = value;
                NotifyPropertyChanged("Email");
            }
        }

        public int Age
        {
            get { return user.Age; }
            set
            {
                user.Age = value;
                NotifyPropertyChanged("Age");
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;

        private void NotifyPropertyChanged(String info)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(info));
            }
        }


    }
}
